<?php
/**
 * Invision Power Services
 * IP.Board v3.0.1
 * 123flashchat Public
 *
 * @author 		$Author: TopCMM $
 * @copyright	(c) 2001 - 2010 TopCMM, Inc.
 * @license		http://www.invisionpower.com/community/board/license.html
 * @package		Invision Power Board
 * @subpackage	123flashchat
 * @link		http://www.123flashchat.com
 */

if ( ! defined( 'IN_IPB' ) )
{
	print "<h1>Incorrect access</h1>You cannot access this file directly. If you have recently upgraded, make sure you upgraded all the relevant files.";
	exit();
}
if(!defined('CACHE_PATH')){
	define('CACHE_PATH', dirname(dirname(dirname(dirname(dirname(dirname(dirname(__FILE__))))))).'/cache/');
}
require_once(dirname(dirname(dirname(__FILE__))).'/extensions/request_remote.php');
class public_123flashchat_123flashchat_status extends ipsCommand{
	/**
	 * Class entry point
	 *
	 * @access	public
	 * @param	object		Registry reference
	 * @return	void		[Outputs to screen/redirects]
	 */
	public function doExecute( ipsRegistry $registry ){
		/* Load language  */
		$this->registry->class_localization->loadLanguageFile( array( 'public_123flashchat' ) );
		$fcsetting = $this->get_fc_config();
		switch($this->request['t']){
			case 'room_list':
	            $fc_rooms = $this->fc_get_room_list($fcsetting);
	            $fc_room_list = '';
	            if(is_array($fc_rooms)){
		            foreach ($fc_rooms as $fc_room){   
		                $fc_client_url = 'index.php?app=123flashchat&room=' . $fc_room['id'];
		                $fc_room_list .= '<p><a href="'. $fc_client_url . '" target="_blank" >' . htmlspecialchars($fc_room['name']) . "</a>(" . $fc_room['count'] . ")</p>"; 
					}
	            }
	            echo "document.write(\"" . str_replace('"','\"',($fc_room_list ? $fc_room_list : 'None')) . "\");";
	            break;
	        case 'user_list':
	            $fc_users = $this->fc_get_user_list($fcsetting);
	            $fc_user_list = '';
	            if(is_array($fc_users)){
		            foreach ($fc_users as $fc_user){
		                $fc_user_list .= (($fc_user_list != '') ? ', ' : '') . str_replace('"','\"',$fc_user['name']);
		            }
	            }
	            echo "document.write(\"" . ($fc_user_list ? $fc_user_list : 'None') . "\");";
	            break;
	        /*case 'camshow' :
	        	$fc_camshows = $this->fc_get_camshow($fcsetting);
	        	$fc_camshow_list = '';
	        	if($fc_camshows){
		            $fc_camshow_list .= '<p style="text-align:center"><a href="index.php?app=123flashchat&room='.$fc_camshows->id.'" target="_blank"><img src="'.$fc_camshows->logo.'" alt="'.$fc_camshows->name.'" style="width:164px; margin: 0 auto;" /><br />'.$fc_camshows->name.'</a></p>';
	            }
	            echo "document.write(\"" . str_replace('"','\"',($fc_camshow_list ? $fc_camshow_list : 'No Camshow Room')) . "\");";
	            break;
	        	
	        	break;*/
			case 'status':
			default:
				$fc_status = $this->fc_get_status($fcsetting);
				if(!$fc_status){
					$fc_status['ln'] = 0;					
	        	    $fc_status['rn'] = 0;
	        	    $fc_status['cn'] = 0;
				}
				$fc_status_str = $fc_status['ln'] . " logins";
				if (array_key_exists('rn', $fc_status)){
					$fc_status_str = $fc_status['rn'] . " rooms, " .  $fc_status['cn'] . " connections, " . $fc_status_str;
				}
	            echo "document.write(\"" . $fc_status_str . "\");";
	            break;		        
			}
	}
	
	function fc_get_status($fcsetting){  
		$data = topcmmRequestRemote::requestRemote(CACHE_PATH."status.js",1);
	    $status_json = substr($data,10);
	    if ((time() > substr($data,0,10)) || !$status_json){
	        $server =  $fcsetting['fc_extendserver'];
	        switch ($server){
	            case 0:
	        	    $status_js = $fcsetting['fc_api_url'] . "online.js";
	        	    if($rs = topcmmRequestRemote::requestRemote($status_js, 1)){
	        	        $status_json = substr($rs,11,-1);
	        	    }
	        	    break;
	        	case 1:
	        	    $status_js = $fcsetting['fc_api_url'] . "online.js?group=" . $fcsetting['fc_group'];
	        	    if($rs = topcmmRequestRemote::requestRemote($status_js,1)){
	        	        $status_json = substr($rs,11,-1);
	        	    }
	        	    break;
	        	case 2:
	        	    $status_js = "http://free.123flashchat.com/freeroomnum.php?roomname=" . $fcsetting['fc_room'];
	        	    if($rs = topcmmRequestRemote::requestRemote($status_js,1)){
                        preg_match("/document.write\('(.*)'\);/",$rs,$matches);
	        	        $status['ln'] = $matches[1];					
	        	        $status['rn'] = 0;
	        	        $status['cn'] = 0;
	        	        $status_json = json_encode($status);
	        	    }
	        	    break;
	        }
			@file_put_contents(CACHE_PATH."status.js",(time() + 120) . $status_json);
	    }
		return json_decode($status_json,true);
	}
	
	function fc_get_room_list($fcsetting){
		$data = topcmmRequestRemote::requestRemote(CACHE_PATH."rooms.js",1);
		$rooms_json = substr($data,10);
	    if ((time() > substr($data,0,10)) || !$rooms_json){
	    	$server =  $fcsetting['fc_extendserver'];
	        switch ($server){
	            case 0:
	        	    $room_js = $fcsetting['fc_api_url'] . "rooms.js";
	        	    break;
	            case 1:
	        	    $room_js = $fcsetting['fc_api_url'] . "rooms.js?group=" . $fcsetting['fc_group'];
	        	    break;
	            case 2:
	            	break;
	        }
	        if($server != 2){
		        if($rs = topcmmRequestRemote::requestRemote($room_js, 1)){
		        	$rooms_json = substr($rs,10,-1);
		        }
		        @file_put_contents(CACHE_PATH."rooms.js",(time() + 120) . $rooms_json);
	        }
	    }	
	    return json_decode($rooms_json, true);
	}
	
	function fc_get_user_list($fcsetting){
		$opts = array('http'=>array('timeout'=>3,));
		$context = stream_context_create($opts);
		$data =  topcmmRequestRemote::requestRemote(CACHE_PATH."users.js",1);
		$users_json = substr($data,10);
	    if ((time() > substr($data,0,10)) || !$users_json){
	    	$server =  $fcsetting['fc_extendserver'];
	        switch ($server){
	            case 0:
	                $rooms = $this->fc_get_room_list($fcsetting);
	                if ($rooms == null){
	                	return null;
	                }
	                $users = array();
	                foreach ($rooms as $room){
	                    $user_js = $fcsetting['fc_api_url'] . "roomonlineusers.js?roomid=" . $room['id'];
	                    if($rs = topcmmRequestRemote::requestRemote($user_js, 1)){
	                        $users = array_merge($users, json_decode(substr($rs,20,-1),true));
	                    }
	                }
	                $users_json = json_encode($users);
	        	    break;
	            case 1:
	        	    $user_js = $fcsetting['fc_api_url'] . "roomonlineusers.js?group=" . $fcsetting['fc_group'];
	        	    if($rs = topcmmRequestRemote::requestRemote($user_js, 1)){
	        	        $users_json = substr($rs,20,-1);
	        	    }
	        	    break;
	        	case 2:
	        		$users = array();       		
	        	    $user_js = "http://free.123flashchat.com/freeroomuser.php?roomname=" . $fcsetting['fc_room'];
	        	    if($rs = topcmmRequestRemote::requestRemote($user_js, 1)){
                        preg_match("/document.write\('(.*)'\);/",$rs,$matches);
	    	            foreach (explode(',', $matches[1]) as $user){
	    	                $users[] = array('name' => $user);
	    	            }
	    	        }
	    	        $users_json = json_encode($users);
	    	        break;
	        }
	        $users_json = $this->filterUserList($users_json);
	        @file_put_contents(CACHE_PATH."users.js",(time() + 120) . $users_json);
	    }
	    return json_decode($users_json, true);
	}
	
	/*public function fc_get_camshow($fcsetting){
		$opts = array('http'=>array('timeout'=>3,));
		$context = stream_context_create($opts); 
        $data = topcmmRequestRemote::requestRemote(CACHE_PATH."camshow.js",1);
		$camshow_json = substr($data,10);
	    if ((time() > substr($data,0,10)) || !$camshow_json){
	    	$camshow_js = '';
		    if($fcsetting['fc_extendserver'] == 2){
				return false;
			}elseif($fcsetting['fc_extendserver'] == 1){
				$camshow_js = topcmmRequestRemote::requestRemote($fcsetting['fc_api_url']."camshow.js?group=".$fcsetting['fc_group'],1);
			}else{
				$camshow_js = topcmmRequestRemote::requestRemote($fcsetting['fc_api_url']."camshow.js",1);
			}
			$camshow_json = substr($camshow_js,12,-1);
	        @file_put_contents(CACHE_PATH."camshow.js",(time() + 60) . $camshow_json);
	    }
	    $camshow_arr = json_decode($camshow_json);
	    if($camshow_arr){
	    	$random_num = rand(0, (count($camshow_arr)-1));
	    	if(substr($camshow_arr[$random_num]->logo, 0,3) != '../' && substr($camshow_arr[$random_num]->logo, 0,7) != 'http://'){
	    		$camshow_arr[$random_num]->logo =  $fcsetting['fc_api_url'].$camshow_arr[$random_num]->logo;
	    	}else{
	    		$camshow_arr[$random_num]->logo = str_replace('../', $fcsetting['fc_api_url'], $camshow_arr[$random_num]->logo);
	    	}
	    	return $camshow_arr[$random_num];
	    }else{
	    	return false;
	    }
	}*/
	
	private function filterUserList($users_json){
		$user_array =  json_decode($users_json,true);
		$user_regroup_array = array();
		$user_tmp_array = array();
		foreach($user_array as $key => $val){
			if (!in_array($val['name'], $user_tmp_array)){
				$user_tmp_array[] = $val['name'];
				$user_regroup_array[$key] = $user_array[$key];
			}
		}
		return json_encode($user_regroup_array);
	}
	
	function get_fc_config(){
		$this->DB->build( array( 'select' => '*',
			'from'   => '123flashchat',
			'where'  => "id=1")
		);
		$this->DB->execute();
		$result = $this->DB->fetch();
		return $result;
	}
	
	/**
	 * Rebuild settings cache
	 *
	 * @access	public
	 * @return	void
	 */
	//$this->cache->setCache( 'settings', $settings, array( 'array' => 1, 'deletefirst' => 1 ) );

}
