<?php
/**
 * Invision Power Services
 * IP.Board v3.0.1
 * 123Flashchat Skin File
 *
 * @author 		$Author: TopCMM $
 * @copyright	(c) 2001 - 2010 TopCMM, Inc.
 * @license		http://www.invisionpower.com/community/board/license.html
 * @package		Invision Power Board
 * @subpackage	123flashchat
 * @link		http://www.123flashchat.com
 */
 
class cp_skin_123flashchat extends output
{

/**
 * Prevent our main destructor being called by this class
 *
 * @access	public
 * @return	void
 */
public function __destruct()
{
}

/**
 * Form to add/edit a calendar
 *
 * @access	public
 * @param	array 		Form elements
 * @param	string		Form title
 * @param	string		Action code
 * @param	string		Button text
 * @param	array 		Calendar data
 * @return	string		HTML
 */
public function flashchatForm($fcsetting, $valid) {

$IPBHTML = "";
//--starthtml--//
$IPBHTML .= '<script type="text/javascript" src="'.$this->settings['js_app_url'].'main_setting.js"></script>';
$IPBHTML .= <<<HTML
<style>
	span.yesyes{
		display: inline-block !important;
		padding: 3px;
		min-width: 95px;
		max-width: 110px;
		text-align: center;
		height: 20px !important;
		background: #e3f6e5;
		border: 1px solid #b4e3b9;
		border-radius: 6px;
		-moz-border-radius: 6px;
	}
	span.yesyes input {
		margin-right: 10px;
	}
	span.yesyes label {
		display: inline-block !important;
		font-weight: normal !important;
		padding-top: 2px;
	}
</style>
<div class='section_title'>
	<h2>{$this->lang->words['fc_settings']}</h2>
	{$fcsetting['fc_error']}
</div>
<form id='adminform' action='{$this->settings['base_url']}&amp;{$this->form_code}&amp;do=save' method='post'>
	<input type='hidden' name='_admin_auth_key' value='{$this->registry->getClass('adminFunctions')->_admin_auth_key}' />
	<div class='acp-box'>
		<h3>{$this->lang->words['fc_settings']}</h3>			
		<table class="ipsTable double_pad"><tbody>
			<tr>
				<td class="field_title" rowspan="3"><strong class="title">{$this->lang->words['fc_server']}</strong></td>
				<td class="field_field">
					<input type="radio" name="extendserver" id="fc_extendserver0" value="0" onclick="changeserver('0')" 
HTML;
if($fcsetting['fc_extendserver'] == 0){
	$IPBHTML .= 'checked="checked"';	
}
$IPBHTML .= <<<HTML
					>
					<label for="fc_extendserver0">{$this->lang->words['server_by_own']}</label>
                    <br /><span class='desctext'>Please download and install 123FlashChat first: <a target="_blank" href="http://www.123flashchat.com/download.html"> http://www.123flashchat.com/download.html</a></span>
				</td>
			</tr>
			<tr>
				<td class="field_field">
					<input type="radio" name="extendserver" id="fc_extendserver1" value="1" onclick="changeserver('1')" 
HTML;
if($fcsetting['fc_extendserver'] == 1){
	$IPBHTML .= 'checked="checked"';	
}
$IPBHTML .= <<<HTML
					>
					<label for="fc_extendserver1">{$this->lang->words['server_by_host']}</label>
                    <br /><span class='desctext'><a target="_blank" href="http://www.123flashchat.com/host.html">For paid host</a>, please set the Chat Client Location like this, for example: http://host71200.123flashchat.com/ipb/, <a target="_blank" href="http://www.123flashchat.com/host.html">Buy host</a>
                    <br /><a target="_blank" href="http://www.123flashchat.com/host/apply.php">For trial host</a>, please setup Chat Client Location like this: http://trial.123flashchat.com/yourhostname
                    <br />Just replace "yourhostname" to the real one when you applied, <a target="_blank" href="http://www.123flashchat.com/host/apply.php">Apply trial host</a></span>
				</td>
			</tr>
			<tr>
				<td class="field_field">
					<input type="radio" name="extendserver" id="fc_extendserver2" value="2" onclick="changeserver('2')" 
HTML;
if($fcsetting['fc_extendserver'] == 2){
	$IPBHTML .= 'checked="checked"';	
}
$IPBHTML .= <<<HTML
					>
					<label for="fc_extendserver2">{$this->lang->words['server_by_free']}</label>
					<br /><span class='desctext'>This chat server mode aims at testing the basic functions, only supported 1 room, no video chat function, and also you don't have the administrator permission of entering this chat room, you can select the mode 1 or 2 to get the full functions and control your chat room.</span>
				</td>
			</tr>
			<tr id="login_chat"
HTML;
if($fcsetting['fc_extendserver'] == 2){
	$IPBHTML .= 'style="display:none;"';	
}
$IPBHTML .= <<<HTML
>
				<td class="field_title"><strong class="title">{$this->lang->words['integration_url']}</stong></td>
				<td class="field_field">To integrate users for auto-login to chat, please open the Chat Admin Panel, then System Settings > Integration Panel, set authentication URL to:<span style="color:red;">
HTML;
$IPBHTML .= $this->settings['public_url'];
$IPBHTML .= <<<HTML
app=123flashchat&amp;module=123flashchat&amp;section=login_chat&amp;username=%username%&amp;password=%password%</span></td>
			</tr>
			<tr id='chat_host'
HTML;
if(!$valid || $fcsetting['fc_extendserver'] != 0){
	$IPBHTML .= 'style="display:none;"';	
}
$IPBHTML .= <<<HTML
>
				<td class="field_title"><strong class="title">{$this->lang->words['chat_server_host']}</strong></td>
				<td class="field_field"><input type="text" id="fc_server_host" name="server_host" size="50" value="{$fcsetting['fc_server_host']}"></td>
			</tr>
			<tr id="chat_port" 
HTML;
if(!$valid || $fcsetting['fc_extendserver'] != 0){
	$IPBHTML .= 'style="display:none;"';	
}
$IPBHTML .= <<<HTML
>
				<td class="field_title"><strong class="title">{$this->lang->words['chat_server_port']}</strong></td>
				<td class="field_field"><input type="text" id="fc_server_port" name="server_port" size="10" value="{$fcsetting['fc_server_port']}"></td>
			</tr>
			<tr id="chat_port_h" 
HTML;
if(!$valid || $fcsetting['fc_extendserver'] != 0){
	$IPBHTML .= 'style="display:none;"';	
}
$IPBHTML .= <<<HTML
>
				<td class="field_title"><strong class="title">{$this->lang->words['chat_http_port']}</strong></td>
				<td class="field_field"><input type="text" id="fc_chat_port_h" name="chat_port_h" size="10" value="{$fcsetting['fc_chat_port_h']}"></td>
			</tr>
			<tr id="client_location" 
HTML;
if($fcsetting['fc_extendserver'] == 2){
	$IPBHTML .= 'style="display:none;"';	
}
$IPBHTML .= <<<HTML
>
				<td class="field_title"><strong class="title">{$this->lang->words['chat_client_location']}</strong></td>
				<td class="field_field"><input type="text" id="fc_client_loc" name="client_loc" size="50" value="{$fcsetting['fc_client_loc']}"></td>
			</tr>
			<tr id="client_mode" 
HTML;
if($fcsetting['fc_extendserver'] == 2){
	$IPBHTML .= 'style="display:none;"';	
}
$IPBHTML .= <<<HTML
			>
				<td class="field_title"><strong class="title">{$this->lang->words['chat_client_mode']}</strong></td>
				<td class="field_field">
					<span class="yesyes">
						<input type="radio" name="client_mode" id="fc_client_mode0" value="0" 
HTML;
if($fcsetting['fc_client_mode'] == 0){
	$IPBHTML .= 'checked="checked"';	
}
$IPBHTML .= <<<HTML
						 /> <label for="fc_client_mode0">{$this->lang->words['html_chat']}</label>
					</span>
					<span class="yesyes">
						<input type="radio" name="client_mode" id="fc_client_mode1" value="1" 
HTML;
if($fcsetting['fc_client_mode'] == 1){
	$IPBHTML .= 'checked="checked"';	
}
$IPBHTML .= <<<HTML
						 /> <label for="fc_client_mode1">{$this->lang->words['flash_chat']}</label>
					</span>
				</td>
			</tr>
			<tr id="room_name" 
HTML;
if($fcsetting['fc_extendserver'] != 2){
	$IPBHTML .= 'style="display:none;"';	
}
$IPBHTML .= <<<HTML
>
				<td class="field_title"><strong class="title">{$this->lang->words['chat_room_name']}</strong></td>
				<td class="field_field"><input type="text" name="room" value="{$fcsetting['fc_room']}"></td>
			</tr>
			<tr id="room_list" 
HTML;
if($fcsetting['fc_extendserver'] == 2){
	$IPBHTML .= 'style="display:none;"';	
}
$IPBHTML .= <<<HTML
>
				<td class="field_title" id="roomlist2" ><strong class="title">{$this->lang->words['show_room_list']}<strong></td>
				<td class="field_field" id="roomlist3">
					<span class="yesno_yes">
						<input type="radio" name="room_list" value="1" id="room_list_yes" 
HTML;
if($fcsetting['fc_room_list'] == 1){
	$IPBHTML .= 'checked="checked"';	
}
$IPBHTML .= <<<HTML
 />
						<label for="room_list_yes">Yes</label>
					</span><span class="yesno_no">
						<input type="radio" name="room_list" value="0" id="room_list_no" 
HTML;
if($fcsetting['fc_room_list'] == 0){
	$IPBHTML .= 'checked="checked"';	
}
$IPBHTML .= <<<HTML
 />
						<label for="room_list_no">No</label>
					</span>
				</td>
			</tr>
			<tr>
				<td class="field_title" id="userlist2" ><strong class="title">{$this->lang->words['show_user_list']}<strong></td>
				<td class="field_field" id="userlist3" >
					<span class="yesno_yes">
						<input type="radio" name="user_list" value="1" id="user_list_yes" 
HTML;
if($fcsetting['fc_user_list'] == 1){
	$IPBHTML .= 'checked="checked"';	
}
$IPBHTML .= <<<HTML
 />
						<label for="user_list_yes">Yes</label>
					</span><span class="yesno_no">
						<input type="radio" name="user_list" value="0" id="user_list_no" 
HTML;
if($fcsetting['fc_user_list'] == 0){
	$IPBHTML .= 'checked="checked"';	
}
$IPBHTML .= <<<HTML
 />
						<label for="user_list_no">No</label>
					</span>
				</td>
			</tr>
			<tr>
				<td class="field_title"><strong class="title">{$this->lang->words['chat_client_size']}<strong></td>
				<td class="field_field">
					<span class="yesno_yes">
						<input type="radio" onclick="showchatsize(0);" name="fullscreen" id="fc_fullscreen_yes" value="1" 
HTML;
if($fcsetting['fc_fullscreen'] == 1){
	$IPBHTML .= 'checked="checked"';	
}
$IPBHTML .= <<<HTML
 />
						<label for="fc_fullscreen_yes">Yes</label>
					</span><span class="yesno_no">
						<input type="radio" onclick="showchatsize(1);" name="fullscreen" id="fc_fullscreen_no" value="0" 
HTML;
if($fcsetting['fc_fullscreen'] == 0){
	$IPBHTML .= 'checked="checked"';	
}
$IPBHTML .= <<<HTML
 />
						<label for="fc_fullscreen_no">No</label>
					</span>
					<span id="chatsize" class='desctext'  
HTML;
if($fcsetting['fc_fullscreen'] == 1){
	$IPBHTML .= 'style="display:none;"';	
}
$IPBHTML .= <<<HTML
> Width : <input type="text" name="client_width" value="{$fcsetting['fc_client_width']}" /> Height : <input type="text" name="client_height" value="{$fcsetting['fc_client_height']}" /></span>
				</td>
			</tr>
			<tr>
				<td class="field_title" ><strong class="title">{$this->lang->words['chat_client_language']}<strong></td>
				<td class="field_field">
					<div id="u_al" 
HTML;
if($fcsetting['fc_extendserver'] == 2){
	$IPBHTML .= 'style="display:none;"';	
}
$IPBHTML .= <<<HTML
 > Note: You can set the language in 123FlashChat Admin Panel -> Client Settings -> Languages </div>
						<select name="client_lang" id="set_lang" 
HTML;
if($fcsetting['fc_extendserver'] != 2){
	$IPBHTML .= 'style="display:none;"';	
}
$IPBHTML .= '>
						<option value="auto" >Auto detect</option>
						<option value="en" '.(($fcsetting['fc_client_lang'] == "en") ? 'selected="selected"' : '').'>English</option>
						<option value="zh-CN" '.(($fcsetting['fc_client_lang'] == "zh-CN") ? 'selected="selected"' : '').'>GB Chinese</option>
						<option value="zh-TW" '.(($fcsetting['fc_client_lang'] == "zh-TW") ? 'selected="selected"' : '').'>Big5 Chinese</option>
						<option value="fr" '.(($fcsetting['fc_client_lang'] == "fr") ? 'selected="selected"' : '').'>French</option>
						<option value="it" '.(($fcsetting['fc_client_lang'] == "it") ? 'selected="selected"' : '').'>Italian</option>
						<option value="de" '.(($fcsetting['fc_client_lang'] == "de") ? 'selected="selected"' : '').'>German</option>
						<option value="nl" '.(($fcsetting['fc_client_lang'] == "nl") ? 'selected="selected"' : '').'>Dutch</option>
						<option value="hu" '.(($fcsetting['fc_client_lang'] == "hu") ? 'selected="selected"' : '').'>Hungarian</option>
						<option value="es" '.(($fcsetting['fc_client_lang'] == "es") ? 'selected="selected"' : '').'>Spanish</option>
						<option value="hr" '.(($fcsetting['fc_client_lang'] == "hr") ? 'selected="selected"' : '').'>Croatian</option>
						<option value="tr" '.(($fcsetting['fc_client_lang'] == "tr") ? 'selected="selected"' : '').'>Turkish</option>
						<option value="ar" '.(($fcsetting['fc_client_lang'] == "ar") ? 'selected="selected"' : '').'>Arabic</option>
						<option value="pt" '.(($fcsetting['fc_client_lang'] == "pt") ? 'selected="selected"' : '').'>Portuguese</option>
						<option value="ru" '.(($fcsetting['fc_client_lang'] == "ru") ? 'selected="selected"' : '').'>Russian</option>
						<option value="ko" '.(($fcsetting['fc_client_lang'] == "ko") ? 'selected="selected"' : '').'>Korean</option>
						<option value="serbian" '.(($fcsetting['fc_client_lang'] == "serbian") ? 'selected="selected"' : '').'>Serbian</option>
						<option value="no" '.(($fcsetting['fc_client_lang'] == "no") ? 'selected="selected"' : '').'>Norwegian</option>
						<option value="ja" '.(($fcsetting['fc_client_lang'] == "ja") ? 'selected="selected"' : '').'>Japanese</option>
					</select>';
$IPBHTML .= <<<HTML
				</td>
			</tr>
			<tr>
				<td class="field_title" ><strong class="title">{$this->lang->words['chat_client_skin']}<strong></td>
				<td class="field_field">
					<div id="u_as" 
HTML;
if($fcsetting['fc_extendserver'] == 2){
	$IPBHTML .= 'style="display:none;"';	
}
$IPBHTML .= '> Note: You can set the skin in 123FlashChat Admin Panel -> Client Settings -> Skin</div>
					<select name="client_skin" id="set_skin" '.(($fcsetting['fc_extendserver'] != 2) ? 'style="display:none;"' : '').'>
						<option value="default" '.(($fcsetting['fc_client_skin'] == "default") ? 'selected="selected"' : '').'>Default</option>
						<option value="green" '.(($fcsetting['fc_client_skin'] == "green") ? 'selected="selected"' : '').'>Green</option>
						<option value="orange" '.(($fcsetting['fc_client_skin'] == "orange") ? 'selected="selected"' : '').'>Orange</option>
						<option value="red" '.(($fcsetting['fc_client_skin'] == "red") ? 'selected="selected"' : '').'>Red</option>
						<option value="black" '.(($fcsetting['fc_client_skin'] == "black") ? 'selected="selected"' : '').'>Black</option>
						<option value="beige" '.(($fcsetting['fc_client_skin'] == "beige") ? 'selected="selected"' : '').'>Beige</option>
						<option value="standard" '.(($fcsetting['fc_client_skin'] == "standard") ? 'selected="selected"' : '').'>Standard</option>
						<option value="clean" '.(($fcsetting['fc_client_skin'] == "clean") ? 'selected="selected"' : '').'>Clean</option>
						<option value="artistic" '.(($fcsetting['fc_client_skin'] == "artistic") ? 'selected="selected"' : '').'>Artistic</option>
						<option value="lightblue" '.(($fcsetting['fc_client_skin'] == "lightblue") ? 'selected="selected"' : '').'>Light Blue</option>';
$IPBHTML .= <<<HTML
					</select>
				</td>
			</tr>
HTML;
/*			<tr id="camshow_enable"
HTML;
if($fcsetting['fc_extendserver'] == 2){
	$IPBHTML .= 'style="display:none;"';	
}
$IPBHTML .= <<<HTML
>
				<td class="field_title"><strong class="title">{$this->lang->words['camshow_enable']}<strong></td>
				<td class="field_field">
					<span class="yesno_yes">
						<input type="radio" name="camshow" value="1" id="camshow_yes" 
HTML;
if($fcsetting['fc_camshow'] == 1){
	$IPBHTML .= 'checked="checked"';	
}
$IPBHTML .= <<<HTML
 />
						<label for="camshow_yes">Yes</label>
					</span><span class="yesno_no">
						<input type="radio" name="camshow" value="0" id="camshow_no" 
HTML;
if($fcsetting['fc_camshow'] == 0){
	$IPBHTML .= 'checked="checked"';	
}
$IPBHTML .= <<<HTML
 />
						<label for="camshow_no">No</label>
					</span>
				</td>
			</tr>
HTML;
*/
$IPBHTML .= <<<HTML
		</tbody></table>
 		<div class="acp-actionbar">
 			<input type="hidden" name="server_loc" id="server_loc" value="{$valid}" />
	        <input type="submit" class="button primary" value="Save">
	    </div>
	</div>
</form>
HTML;

//--endhtml--//
return $IPBHTML;
}

/**
 * RSS recurring event
 *
 * @access	public
 * @param	array 		Event data
 * @return	string		HTML
 */
public function flashchat_admin_panel($fcsetting, $admin_url ) {

$IPBHTML = "";
//--starthtml--//

$IPBHTML .= <<<HTML
<div class='section_title'>
	<h2>{$this->lang->words['fc_admin_panel']}</h2>
</div>
HTML;
if ($this->settings['fc_extendserver'] != 2){
$IPBHTML .= <<<HTML
	<object classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000" codebase="http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=6,0,19,0" id="topcmm_123flashchat"  type="application/x-shockwave-flash" width="100%" height="600">
	    <param name=movie value="{$admin_url}">
	    <param name=quality value="high">
	    <param name="menu" value="false">
	    <param name="allowScriptAccess" value="always">
	    <embed src="{$admin_url}" quality="high" menu="false" allowScriptAccess="always" width="100%" height="600" type="application/x-shockwave-flash" pluginspace="http://www.macromedia.com/go/getflashplayer" name="topcmm_123flashchat"></embed>
	</object>
	<script src="{$fcsetting['fc_client_loc']}123flashchat.js"></script>
<br />
HTML;
}else{
	$IPBHTML .= <<<HTML
		<p>{$this->lang->words['fc_admin_free']}</p>
		<p><a href="http://www.123flashchat.com/admin-panel-free.html" target="_blank">Live Demo</a></p>
HTML;
}
//--endhtml--//
return $IPBHTML;
}

}
